"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TreeNode = void 0;
class TreeNode {
    constructor(key, value, children) {
        this.key = key;
        this.value = value || undefined;
        this.children = children || [];
    }
    addChildren(children) {
        if (!this.children) {
            this.children = [];
        }
        if (children instanceof TreeNode) {
            this.children.push(children);
        }
        else {
            this.children = this.children.concat(children);
        }
    }
    getHeight() {
        let maxDepth = 0;
        if (this) {
            const bfs = (node, level) => {
                if (level > maxDepth) {
                    maxDepth = level;
                }
                const { children } = node;
                if (children) {
                    for (let i = 0, len = children.length; i < len; i++) {
                        bfs(children[i], level + 1);
                    }
                }
            };
            bfs(this, 0);
        }
        return maxDepth;
    }
}
exports.TreeNode = TreeNode;
